program kruskal;

{$APPTYPE CONSOLE}

var
  ea, eb, ew, parent, size: array[-1..110000] of integer;
  i, n, m, k, treelen, a, b: integer;

procedure exchg (apar, bpar: integer);
var temp: integer;
begin
  temp := ew[apar];
  ew[apar] := ew[bpar];
  ew[bpar] := temp;
  temp := ea[apar];
  ea[apar] := ea[bpar];
  ea[bpar] := temp;
  temp := eb[apar];
  eb[apar] := eb[bpar];
  eb[bpar] := temp;
end;

procedure restore_reg (il, bpar: integer);
var jl: integer;
begin
  repeat
    jl := il;
    if (il*2 <= bpar) and (ew[il*2] > ew[jl]) then jl := il*2;
    if (il*2+1 <= bpar) and (ew[il*2+1] > ew[jl]) then jl := il*2+1;
    if il <> jl then
    begin
      exchg(il, jl);
      il := jl;
      jl := 0;
    end;
  until il = jl;
end;

function getparent (apar: integer): integer;
var il, jl: integer;
begin
  il := apar;
  while parent[il] <> 0 do il := parent[il];

  jl := il;
  while parent[apar] <> 0 do
  begin
    il := parent[apar];
    parent[apar] := jl;
    apar := il;
  end;
  result := jl;
end;

procedure merge (apar, bpar: integer);
var temp: integer;
begin
  if size[apar] < size[bpar] then
  begin
    temp := apar;
    apar := bpar;
    bpar := temp;
  end;

  inc(size[apar], size[bpar] + 1);
  parent[bpar] := apar;
end;

begin
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);

  read (n, m);
  for i := 1 to m do
    read (ea[i], eb[i], ew[i]);

  for i := m downto 1 do  restore_reg(i, m);
  for i := m downto 2 do
  begin
    exchg(1, i);
    restore_reg(1, i - 1);
  end;

  k := 0; i := 1; treelen := 0;
  while (i <= m) and (k < n - 1) do
  begin
    a := getparent (ea[i]);
    b := getparent (eb[i]);

    if a <> b then
    begin
      merge (a, b);
      inc (treelen, ew[i]);
      inc(k);
    end;

    inc(i);
  end;

  if k < n - 1 then write (-1)
  else write (treelen);
  close (input); close (output);
end.